% This is simulation code provided to help with the development of
% IEEE 802.3dm.
%
% This code is provided for reference to allow independent evaluation
% of the accuracy and applicability of the simulation results shared in
% IEEE 802.3dm presentations by the author.
%
% Written by Ragnar Jonsson, affiliated with Marvell Technology, Inc.
% Version 1.0, December 16th, 2024
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
% DEALINGS IN THE SOFTWARE.
function out = Qformat(format)
  if(nargin < 1)
    format = 0;
  end

  switch(format(1))
    case 'q'
      bits = strsplit(strsplit(format,'q'){end},'.');
      i = eval(bits{1});
      b = eval(bits{2});
      st = 0.5^b;
      mx = 2^i - st;
      mn = -2^i;
      out = [mn st mx];
    case 'p'
      pam_levels = str2num(format(4:end));
      st = 2/(pam_levels-1);
      out = [-1 st 1];
    otherwise
      out = format;
    end
end
