% This is simulation code provided to help with the development of
% IEEE 802.3dm.
%
% This code is provided for reference to allow independent evaluation
% of the accuracy and applicability of the simulation results shared in
% IEEE 802.3dm presentations by the author.
%
% Written by Ragnar Jonsson, affiliated with Marvell Technology, Inc.
% Version 1.0, December 16th, 2024
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
% DEALINGS IN THE SOFTWARE.
function state = channel(state,port1_in,port2_in)
%  Channel Model
	if(nargin<1)
		clear state;
		state.p11 = Filter();
		state.p12 = Filter();
		state.p21 = Filter();
		state.p22 = Filter();
		state.port1_out = 0;
		state.port2_out = 0;
		state.p11.b = 0;
		state.p22.b = 0;
	else
		state.p11 = Filter(state.p11,port1_in);
		state.p12 = Filter(state.p12,port1_in);
		state.p21 = Filter(state.p21,port2_in);
		state.p22 = Filter(state.p22,port2_in);
		state.port1_out = Add(state.p11.out,state.p21.out);
		state.port2_out = Add(state.p12.out,state.p22.out);
	end
end
