% This is simulation code provided to help with the development of
% IEEE 802.3dm.
%
% This code is provided for reference to allow independent evaluation
% of the accuracy and applicability of the simulation results shared in
% IEEE 802.3dm presentations by the author.
%
% Written by Ragnar Jonsson, affiliated with Marvell Technology, Inc.
% Version 1.0, December 16th, 2024
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
% OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
% THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
% FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
% DEALINGS IN THE SOFTWARE.
function state = phy(state,rx_in,tx_in)
%  PHY top level
	if(nargin<1)
		clear state;
		state.pma = pma();
		state.afe = afe();
		state.pcb = pcb();
		state.rx_out = 0;
		state.tx_out = 0;
	else
		state.pma = pma(state.pma,state.afe.rx_out,tx_in);
		state.afe = afe(state.afe,state.pcb.rx_out,state.pma.tx_out);
		state.pcb = pcb(state.pcb,rx_in,state.afe.tx_out);
		state.rx_out = state.pma.rx_out;
		state.tx_out = state.pcb.tx_out;
	end
end
